## ros-foxy-rosidl-runtime-c 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rosidl_runtime_c C)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosidl_typesupport_interface REQUIRED)

add_library(${PROJECT_NAME}
  "src/message_type_support.c"
  "src/primitives_sequence_functions.c"
  "src/sequence_bound.c"
  "src/service_type_support.c"
  "src/string_functions.c"
  "src/u16string_functions.c"
)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
ament_target_dependencies(${PROJECT_NAME}
  "rcutils"
  "rosidl_typesupport_interface")
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set_target_properties(${PROJECT_NAME} PROPERTIES
    COMPILE_OPTIONS -Wall -Wextra -Wpedantic)
endif()
if(WIN32)
  target_compile_definitions(${PROJECT_NAME}
    PRIVATE "ROSIDL_GENERATOR_C_BUILDING_DLL")
endif()

if(BUILD_TESTING AND NOT RCUTILS_DISABLE_FAULT_INJECTION)
  target_compile_definitions(${PROJECT_NAME} PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
endif()

ament_export_dependencies(rcutils rosidl_typesupport_interface)
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})

ament_index_register_resource("rosidl_runtime_packages")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(performance_test_fixture REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS performance_test_fixture::performance_test_fixture INTERFACE_INCLUDE_DIRECTORIES)
  ament_lint_auto_find_test_dependencies()

  # For gtest
  enable_language(CXX)
  # Default to C++14
  if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
  endif()

  find_package(ament_cmake_gtest REQUIRED)

  ament_add_gtest(test_message_type_support test/test_message_type_support.cpp)
  if(TARGET test_message_type_support)
    target_include_directories(test_message_type_support PUBLIC include)
    target_link_libraries(test_message_type_support ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_primitives_sequence_functions test/test_primitives_sequence_functions.cpp)
  if(TARGET test_primitives_sequence_functions)
    target_include_directories(test_primitives_sequence_functions PUBLIC include)
    target_link_libraries(test_primitives_sequence_functions ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_sequence_bound test/test_sequence_bound.cpp)
  if(TARGET test_sequence_bound)
    ament_target_dependencies(test_sequence_bound
      "rosidl_typesupport_interface")
    target_include_directories(test_sequence_bound PUBLIC include)
    target_link_libraries(test_sequence_bound ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_service_type_support test/test_service_type_support.cpp)
  if(TARGET test_service_type_support)
    target_include_directories(test_service_type_support PUBLIC include)
    target_link_libraries(test_service_type_support ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_string_functions test/test_string_functions.cpp)
  if(TARGET test_string_functions)
    target_include_directories(test_string_functions PUBLIC include)
    target_link_libraries(test_string_functions ${PROJECT_NAME})
    target_compile_definitions(test_string_functions PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  ament_add_gtest(test_u16string_functions test/test_u16string_functions.cpp)
  if(TARGET test_u16string_functions)
    target_include_directories(test_u16string_functions PUBLIC include)
    target_link_libraries(test_u16string_functions ${PROJECT_NAME})
    target_compile_definitions(test_u16string_functions PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  add_performance_test(benchmark_string_conversion test/benchmark/benchmark_string_conversion.cpp)
  if(TARGET benchmark_string_conversion)
    target_include_directories(benchmark_string_conversion PUBLIC include)
    target_link_libraries(benchmark_string_conversion ${PROJECT_NAME})
  endif()
endif()

install(
  DIRECTORY include/
  DESTINATION include
)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

ament_package()

=== debian/changelog ===
ros-foxy-rosidl-runtime-c (1.3.1-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Sat, 27 May 2023 00:00:00 -0000

ros-foxy-rosidl-runtime-c (1.3.0-1focal) focal; urgency=high

  * Use rcutils allocators in rosidl_generator_c (#584 <https://github.com/ros2/rosidl/issues/584>)
  * Implement equality operator function for C messages. (#648 <https://github.com/ros2/rosidl/issues/648>) (#667 <https://github.com/ros2/rosidl/issues/667>)
  * Implement copy function for C messages (#650 <https://github.com/ros2/rosidl/issues/650>) (#667 <https://github.com/ros2/rosidl/issues/667>)
  * Contributors: Michel Hidalgo, Nikolai Morin, Pablo Garrido

 -- William Woodall <william@osrfoundation.org>  Tue, 20 Sep 2022 00:00:00 -0000

ros-foxy-rosidl-runtime-c (1.2.1-1focal) focal; urgency=high

  * Update quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#582 <https://github.com/ros2/rosidl/issues/582>)
  * Contributors: Simon Honigmann

 -- William Woodall <william@osrfoundation.org>  Wed, 14 Apr 2021 00:00:00 -0000

ros-foxy-rosidl-runtime-c (1.2.0-1focal) focal; urgency=high

  * Fix item number in QD (#546 <https://github.com/ros2/rosidl/issues/546>) (#547 <https://github.com/ros2/rosidl/issues/547>)
  * Update QD links for Foxy
  * QD: Add links to hosted API docs (#533 <https://github.com/ros2/rosidl/issues/533>)
  * Updated Quality Level to 1 (#532 <https://github.com/ros2/rosidl/issues/532>)
  * Add benchmarks for rosidl_runtime_* packages (#521 <https://github.com/ros2/rosidl/issues/521>)
  * Add rcutils dependency (#534 <https://github.com/ros2/rosidl/issues/534>)
  * Add fault injection macros and test (#509 <https://github.com/ros2/rosidl/issues/509>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, Louise Poubel, Scott K Logan, Stephen Brawner

 -- William Woodall <william@osrfoundation.org>  Tue, 08 Dec 2020 00:00:00 -0000

ros-foxy-rosidl-runtime-c (1.1.0-1focal) focal; urgency=high

  * Update rosidl_runtime_c QD to QL 2 (#500 <https://github.com/ros2/rosidl/issues/500>)
  * Contributors: Stephen Brawner

 -- William Woodall <william@osrfoundation.org>  Mon, 17 Aug 2020 00:00:00 -0000

ros-foxy-rosidl-runtime-c (1.0.1-1focal) focal; urgency=high

  * Add Security Vulnerability Policy pointing to REP-2006 (#494 <https://github.com/ros2/rosidl/issues/494>)
  * QD Update Version Stability to stable version (#495 <https://github.com/ros2/rosidl/issues/495>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette

 -- William Woodall <william@osrfoundation.org>  Wed, 03 Jun 2020 00:00:00 -0000

ros-foxy-rosidl-runtime-c (1.0.0-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Fri, 22 May 2020 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.9.2-1focal) focal; urgency=high

  * Update API documentation (#488 <https://github.com/ros2/rosidl/issues/488>)
  * Add tests (#484 <https://github.com/ros2/rosidl/issues/484>)
  * Add feature documentation (#482 <https://github.com/ros2/rosidl/issues/482>)
  * Contributors: brawner

 -- William Woodall <william@osrfoundation.org>  Tue, 19 May 2020 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.9.1-1focal) focal; urgency=high

  * Package READMEs and QUALITY_DECLARATIONS for runtime packages (#480 <https://github.com/ros2/rosidl/issues/480>)
  * Documentation: action, message, service typesupport and message bounds (#472 <https://github.com/ros2/rosidl/issues/472>)
  * Added doxyfile in rosidl_runtime_c and rosidl_runtime_cpp (#474 <https://github.com/ros2/rosidl/issues/474>)
  * Contributors: Alejandro Hernández Cordero, brawner

 -- William Woodall <william@osrfoundation.org>  Fri, 08 May 2020 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.9.0-1focal) focal; urgency=high

  * Rename message_bounds structure for consistency (#475 <https://github.com/ros2/rosidl/issues/475>)
  * Rename rosidl_runtime_c__String__bounds to singular (#476 <https://github.com/ros2/rosidl/issues/476>)
  * Document string structs and sequence functions (#466 <https://github.com/ros2/rosidl/issues/466>)
  * Export targets in addition to include directories / libraries (#465 <https://github.com/ros2/rosidl/issues/465>)
  * Rename rosidl_runtime_c_message_initialization to rosidl_runtime_c__message_initialization (#464 <https://github.com/ros2/rosidl/issues/464>)
  * Rename rosidl_generator_c 'namespace' to rosidl_runtime_c (#458 <https://github.com/ros2/rosidl/issues/458>)
  * Split rosidl_generator_c and rosidl_generator_cpp in two: rosidl_generator_x and rosidl_runtime_x (#442 <https://github.com/ros2/rosidl/issues/442>)
  * Contributors: Alejandro Hernández Cordero, Dirk Thomas, Michael Carroll

 -- William Woodall <william@osrfoundation.org>  Fri, 24 Apr 2020 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.8.2-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Fri, 17 Jan 2020 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.8.1-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 23 Oct 2019 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.8.0-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Tue, 24 Sep 2019 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.7.3-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 29 May 2019 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.7.2-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Mon, 20 May 2019 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.7.1-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Wed, 08 May 2019 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.7.0-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Fri, 12 Apr 2019 00:00:00 -0000

ros-foxy-rosidl-runtime-c (0.6.3-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Thu, 07 Feb 2019 00:00:00 -0000



=== debian/control ===
Source: ros-foxy-rosidl-runtime-c
Section: misc
Priority: optional
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake-ros, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-performance-test-fixture <!nocheck>, ros-foxy-rcutils, ros-foxy-rosidl-typesupport-interface, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rosidl-runtime-c
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ament-cmake, ros-foxy-rcutils, ros-foxy-rosidl-typesupport-interface, ros-foxy-ros-workspace
Description: Generate the ROS interfaces in C.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rosidl-runtime-c//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
